Index: vendors/IOIPSL/current/src/histcom.f90
===================================================================
--- vendors/IOIPSL/current/src/histcom.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/histcom.f90	(revision 1991)
@@ -584,344 +547,244 @@
 !- phid    : Id of the created grid
 !-
-!- OPTIONAL
-!-
-!- opt_rectilinear : If true we know the grid is rectilinear.
-!-
+!- Optional INPUT arguments
+!-
+!- For rectilinear or irregular grid
+!- x_1d  : The longitudes
+!- y_1d  : The latitudes
+!- For regular grid
+!- x_2d  : The longitudes
+!- y_2d  : The latitudes
+!- One pair (x_1d,y_1d) or (x_2d,y_2d) must be supplied.
+!-
+!- For irregular grid.
+!- x_bnds : The boundaries of the grid in longitude
+!- y_bnds : The boundaries of the grid in latitude
 !---------------------------------------------------------------------
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid,pim,pjm
-  REAL,INTENT(IN),DIMENSION(pim,pjm) :: plon,plat
+  INTEGER,INTENT(IN) :: k_typ
+  INTEGER,INTENT(IN) :: idf,pim,pjm
   CHARACTER(LEN=*),INTENT(IN) :: phname,phtitle
   INTEGER,INTENT(OUT) :: phid
-  LOGICAL,INTENT(IN),OPTIONAL :: opt_rectilinear
+  REAL,DIMENSION(:),INTENT(IN),OPTIONAL :: x_1d,y_1d
+  REAL,DIMENSION(:,:),INTENT(IN),OPTIONAL :: x_2d,y_2d
+  REAL,DIMENSION(:,:),INTENT(IN),OPTIONAL :: x_bnds,y_bnds
 !-
   CHARACTER(LEN=25) :: lon_name,lat_name
-  CHARACTER(LEN=80) :: tmp_title,tmp_name
-  INTEGER :: ndim
-  INTEGER,DIMENSION(2) :: dims
+  CHARACTER(LEN=30) :: lonbound_name,latbound_name
+  INTEGER :: i_s,i_e
+  INTEGER,DIMENSION(2) :: dims,dims_b
+  INTEGER :: nbbounds
+  INTEGER :: nlonidb,nlatidb,twoid
+  LOGICAL :: transp = .FALSE.
+  REAL,ALLOCATABLE,DIMENSION(:,:) :: bounds_trans
+  REAL :: wmn,wmx
   INTEGER :: nlonid,nlatid
-  INTEGER :: orix,oriy,par_szx,par_szy
-  INTEGER :: iret,ncid
-  LOGICAL :: rectilinear
+  INTEGER :: o_x,o_y,s_x,s_y
+  INTEGER :: iret,nfid
+  CHARACTER(LEN=11) :: c_nam
   LOGICAL :: l_dbg
 !---------------------------------------------------------------------
   CALL ipsldbg (old_status=l_dbg)
 !-
+  IF     (k_typ == 1) THEN
+    c_nam = 'histh_reg1d'
+  ELSEIF (k_typ == 2) THEN
+    c_nam = 'histh_reg2d'
+  ELSEIF (k_typ == 3) THEN
+    c_nam = 'histh_irreg'
+  ELSE
+    CALL ipslerr (3,"histhori", &
+ &    'Illegal value of k_typ argument','in internal interface','?')
+  ENDIF
+!-
 ! 1.0 Check that all fits in the buffers
 !-
-  IF (    (pim /= full_size(pfileid,1)) &
-    & .OR.(pjm /= full_size(pfileid,2)) ) THEN
+  IF (    (pim /= W_F(idf)%full_size(1)) &
+ &    .OR.(W_F(idf)%regular.AND.(pjm /= W_F(idf)%full_size(2)))  &
+ &    .OR.(.NOT.W_F(idf)%regular.AND.(W_F(idf)%full_size(2) /= 1)) ) THEN
     CALL ipslerr (3,"histhori", &
-   &  'The new horizontal grid does not have the same size', &
-   &  'as the one provided to histbeg. This is not yet ', &
-   &  'possible in the hist package.')
-  ENDIF
-!-
-  IF (PRESENT(opt_rectilinear)) THEN
-    rectilinear = opt_rectilinear
-  ELSE
-    rectilinear = .FALSE.
+ &   'The new horizontal grid does not have the same size', &
+ &   'as the one provided to histbeg. This is not yet ', &
+ &   'possible in the hist package.')
   ENDIF
 !-
 ! 1.1 Create all the variables needed
 !-
-  IF (l_dbg) WRITE(*,*) "histhori_regular 1.0"
-!-
-  ncid = ncdf_ids(pfileid)
-!-
-  ndim = 2
-  dims(1:2) = (/ xid(pfileid),yid(pfileid) /)
-!-
-  tmp_name = phname
-  IF (rectilinear) THEN
-    IF (nb_hax(pfileid) == 0) THEN
+  IF (l_dbg) WRITE(*,*) c_nam//" 1.0"
+!-
+  nfid = W_F(idf)%ncfid
+!-
+  IF (k_typ == 3) THEN
+    IF     (SIZE(x_bnds,DIM=1) == pim) THEN
+      nbbounds = SIZE(x_bnds,DIM=2)
+      transp = .TRUE.
+    ELSEIF (SIZE(x_bnds,DIM=2) == pim) THEN
+      nbbounds = SIZE(x_bnds,DIM=1)
+      transp = .FALSE.
+    ELSE
+      CALL ipslerr (3,"histhori", &
+ &     'The boundary variable does not have any axis corresponding', &
+ &     'to the size of the longitude or latitude variable','.')
+    ENDIF
+    ALLOCATE(bounds_trans(nbbounds,pim))
+    iret = NF90_DEF_DIM(nfid,'nbnd',nbbounds,twoid)
+    dims_b(1:2) = (/ twoid,W_F(idf)%xid /)
+  ENDIF
+!-
+  dims(1:2) = (/ W_F(idf)%xid,W_F(idf)%yid /)
+!-
+  IF     (k_typ == 1) THEN
+    IF (W_F(idf)%n_hax == 0) THEN
       lon_name = 'lon'
       lat_name = 'lat'
     ELSE
-      lon_name = 'lon_'//TRIM(tmp_name)
-      lat_name = 'lat_'//TRIM(tmp_name)
-    ENDIF
-  ELSE
-    IF (nb_hax(pfileid) == 0) THEN
+      lon_name = 'lon_'//TRIM(phname)
+      lat_name = 'lat_'//TRIM(phname)
+    ENDIF
+  ELSEIF (k_typ == 2) THEN
+    IF (W_F(idf)%n_hax == 0) THEN
       lon_name = 'nav_lon'
       lat_name = 'nav_lat'
     ELSE
-      lon_name = 'nav_lon_'//TRIM(tmp_name)
-      lat_name = 'nav_lat_'//TRIM(tmp_name)
-    ENDIF
+      lon_name = 'nav_lon_'//TRIM(phname)
+      lat_name = 'nav_lat_'//TRIM(phname)
+    ENDIF
+  ELSEIF (k_typ == 3) THEN
+    IF (W_F(idf)%n_hax == 0) THEN
+      lon_name = 'nav_lon'
+      lat_name = 'nav_lat'
+    ELSE
+      lon_name = 'nav_lon_'//TRIM(phname)
+      lat_name = 'nav_lat_'//TRIM(phname)
+    ENDIF
+    lonbound_name = TRIM(lon_name)//'_bounds'
+    latbound_name = TRIM(lat_name)//'_bounds'
   ENDIF
 !-
 ! 1.2 Save the informations
 !-
-  phid =  nb_hax(pfileid)+1
-  nb_hax(pfileid) = phid
-!-
-  hax_name(pfileid,phid,1:2) = (/ lon_name,lat_name /)
-  tmp_title = phtitle
+  phid = W_F(idf)%n_hax+1
+  W_F(idf)%n_hax = phid
+  W_F(idf)%hax_name(phid,1:2) = (/ lon_name,lat_name /)
 !-
 ! 2.0 Longitude
 !-
-  IF (l_dbg) WRITE(*,*) "histhori_regular 2.0"
-!-
-  IF (rectilinear) THEN
-    ndim = 1
-    dims(1:1) = (/ xid(pfileid) /)
-  ENDIF
-  iret = NF90_DEF_VAR (ncid,lon_name,NF90_FLOAT,dims(1:ndim),nlonid)
-  IF (rectilinear) THEN
-    iret = NF90_PUT_ATT (ncid,nlonid,'axis',"X")
-  ENDIF
-  iret = NF90_PUT_ATT (ncid,nlonid,'standard_name',"longitude")
-  iret = NF90_PUT_ATT (ncid,nlonid,'units',"degrees_east")
-  iret = NF90_PUT_ATT (ncid,nlonid,'valid_min', &
- &                     REAL(MINVAL(plon),KIND=4))
-  iret = NF90_PUT_ATT (ncid,nlonid,'valid_max', &
- &                     REAL(MAXVAL(plon),KIND=4))
-  iret = NF90_PUT_ATT (ncid,nlonid,'long_name',"Longitude")
-  iret = NF90_PUT_ATT (ncid,nlonid,'nav_model',TRIM(tmp_title))
+  IF (l_dbg) WRITE(*,*) c_nam//" 2.0"
+!-
+  i_s = 1;
+  IF ( (k_typ == 1).OR.(k_typ == 3) ) THEN
+    i_e = 1; wmn = MINVAL(x_1d); wmx = MAXVAL(x_1d);
+  ELSEIF (k_typ == 2) THEN
+    i_e = 2; wmn = MINVAL(x_2d); wmx = MAXVAL(x_2d);
+  ENDIF
+  iret = NF90_DEF_VAR(nfid,lon_name,NF90_REAL4,dims(i_s:i_e),nlonid)
+  IF (k_typ == 1) THEN
+    iret = NF90_PUT_ATT(nfid,nlonid,'axis',"X")
+  ENDIF
+  iret = NF90_PUT_ATT(nfid,nlonid,'standard_name',"longitude")
+  iret = NF90_PUT_ATT(nfid,nlonid,'units',"degrees_east")
+  iret = NF90_PUT_ATT(nfid,nlonid,'valid_min',REAL(wmn,KIND=4))
+  iret = NF90_PUT_ATT(nfid,nlonid,'valid_max',REAL(wmx,KIND=4))
+  iret = NF90_PUT_ATT(nfid,nlonid,'long_name',"Longitude")
+  iret = NF90_PUT_ATT(nfid,nlonid,'nav_model',TRIM(phtitle))
+!-
+  IF (k_typ == 3) THEN
+!---
+!-- 2.1 Longitude bounds
+!---
+    iret = NF90_PUT_ATT(nfid,nlonid,'bounds',TRIM(lonbound_name))
+    iret = NF90_DEF_VAR(nfid,lonbound_name,NF90_REAL4,dims_b(1:2),nlonidb)
+    iret = NF90_PUT_ATT(nfid,nlonidb,'long_name', &
+ &          'Boundaries for coordinate variable '//TRIM(lon_name))
+  ENDIF
 !-
 ! 3.0 Latitude
 !-
-  IF (l_dbg) WRITE(*,*) "histhori_regular 3.0"
-!-
-  IF (rectilinear) THEN
-    ndim = 1
-    dims(1:1) = (/ yid(pfileid) /)
-  ENDIF
-  iret = NF90_DEF_VAR (ncid,lat_name,NF90_FLOAT,dims(1:ndim),nlatid)
-  IF (rectilinear) THEN
-    iret = NF90_PUT_ATT (ncid,nlatid,'axis',"Y")
-  ENDIF
-  iret = NF90_PUT_ATT (ncid,nlatid,'standard_name',"latitude")
-  iret = NF90_PUT_ATT (ncid,nlatid,'units',"degrees_north")
-  iret = NF90_PUT_ATT (ncid,nlatid,'valid_min', &
- &                     REAL(MINVAL(plat),KIND=4))
-  iret = NF90_PUT_ATT (ncid,nlatid,'valid_max', &
- &                     REAL(MAXVAL(plat),KIND=4))
-  iret = NF90_PUT_ATT (ncid,nlatid,'long_name',"Latitude")
-  iret = NF90_PUT_ATT (ncid,nlatid,'nav_model',TRIM(tmp_title))
-!-
-  iret = NF90_ENDDEF (ncid)
+  IF (l_dbg) WRITE(*,*) c_nam//" 3.0"
+!-
+  i_e = 2;
+  IF ( (k_typ == 1).OR.(k_typ == 3) ) THEN
+    i_s = 2; wmn = MINVAL(y_1d); wmx = MAXVAL(y_1d);
+  ELSEIF (k_typ == 2) THEN
+    i_s = 1; wmn = MINVAL(y_2d); wmx = MAXVAL(y_2d);
+  ENDIF
+  iret = NF90_DEF_VAR(nfid,lat_name,NF90_REAL4,dims(i_s:i_e),nlatid)
+  IF (k_typ == 1) THEN
+    iret = NF90_PUT_ATT(nfid,nlatid,'axis',"Y")
+  ENDIF
+!-
+  iret = NF90_PUT_ATT(nfid,nlatid,'standard_name',"latitude")
+  iret = NF90_PUT_ATT(nfid,nlatid,'units',"degrees_north")
+  iret = NF90_PUT_ATT(nfid,nlatid,'valid_min',REAL(wmn,KIND=4))
+  iret = NF90_PUT_ATT(nfid,nlatid,'valid_max',REAL(wmx,KIND=4))
+  iret = NF90_PUT_ATT(nfid,nlatid,'long_name',"Latitude")
+  iret = NF90_PUT_ATT(nfid,nlatid,'nav_model',TRIM(phtitle))
+!-
+  IF (k_typ == 3) THEN
+!---
+!-- 3.1 Latitude bounds
+!---
+    iret = NF90_PUT_ATT(nfid,nlatid,'bounds',TRIM(latbound_name))
+    iret = NF90_DEF_VAR(nfid,latbound_name,NF90_REAL4,dims_b(1:2),nlatidb)
+    iret = NF90_PUT_ATT(nfid,nlatidb,'long_name', &
+ &          'Boundaries for coordinate variable '//TRIM(lat_name))
+  ENDIF
+!-
+  iret = NF90_ENDDEF(nfid)
 !-
 ! 4.0 storing the geographical coordinates
 !-
-  IF (l_dbg) WRITE(*,*) "histhori_regular 4.0"
-!-
-  orix = slab_ori(pfileid,1)
-  oriy = slab_ori(pfileid,2)
-  par_szx = slab_sz(pfileid,1)
-  par_szy = slab_sz(pfileid,2)
-!-
-! Transfer the longitude
-!-
-  IF (rectilinear) THEN
-    iret = NF90_PUT_VAR (ncid,nlonid,plon(orix:orix+par_szx-1,1))
-  ELSE
-    iret = NF90_PUT_VAR (ncid,nlonid, &
- &           plon(orix:orix+par_szx-1,oriy:oriy+par_szy-1))
-  ENDIF
-!-
-! Transfer the latitude
-!-
-  IF (rectilinear) THEN
-    iret = NF90_PUT_VAR (ncid,nlatid,plat(1,oriy:oriy+par_szy-1))
-  ELSE
-    iret = NF90_PUT_VAR (ncid,nlatid, &
- &           plat(orix:orix+par_szx-1,oriy:oriy+par_szy-1))
-  ENDIF
-!-
-  iret = NF90_REDEF (ncid)
-!------------------------------
-END SUBROUTINE histhori_regular
+  IF (l_dbg) WRITE(*,*) c_nam//" 4.0"
+!-
+  IF ( (k_typ == 1).OR.(k_typ == 2) ) THEN
+    o_x = W_F(idf)%slab_ori(1)
+    o_y = W_F(idf)%slab_ori(2)
+    s_x = W_F(idf)%slab_siz(1)
+    s_y = W_F(idf)%slab_siz(2)
+!---
+!-- Transfer the longitude and  the latitude
+!---
+    IF     (k_typ == 1) THEN
+      iret = NF90_PUT_VAR(nfid,nlonid,x_1d(o_x:o_x+s_x-1))
+      iret = NF90_PUT_VAR(nfid,nlatid,y_1d(o_y:o_y+s_y-1))
+    ELSEIF (k_typ == 2) THEN
+      iret = NF90_PUT_VAR(nfid,nlonid, &
+ &            x_2d(o_x:o_x+s_x-1,o_y:o_y+s_y-1))
+      iret = NF90_PUT_VAR(nfid,nlatid, &
+ &            y_2d(o_x:o_x+s_x-1,o_y:o_y+s_y-1))
+    ENDIF
+  ELSEIF (k_typ == 3) THEN
+!---
+!-- Transfer the longitude and the longitude bounds
+!---
+    iret = NF90_PUT_VAR(nfid,nlonid,x_1d(1:pim))
+!---
+    IF (transp) THEN
+      bounds_trans = TRANSPOSE(x_bnds)
+    ELSE
+      bounds_trans = x_bnds
+    ENDIF
+    iret = NF90_PUT_VAR(nfid,nlonidb,bounds_trans(1:nbbounds,1:pim))
+!---
+!-- Transfer the latitude and the latitude bounds
+!---
+    iret = NF90_PUT_VAR(nfid,nlatid,y_1d(1:pim))
+!---
+    IF (transp) THEN
+      bounds_trans = TRANSPOSE(y_bnds)
+    ELSE
+      bounds_trans = y_bnds
+    ENDIF
+    iret = NF90_PUT_VAR(nfid,nlatidb,bounds_trans(1:nbbounds,1:pim))
+!---
+    DEALLOCATE(bounds_trans)
+  ENDIF
+!-
+  iret = NF90_REDEF(nfid)
+!-----------------------
+END SUBROUTINE histh_all
 !===
-SUBROUTINE histhori_irregular &
- &  (pfileid,pim,plon,plon_bounds,plat,plat_bounds, &
- &   phname,phtitle,phid)
-!---------------------------------------------------------------------
-!- This subroutine is made to declare a new horizontale grid.
-!- It has to have the same number of points as
-!- the original and thus in this routine we will only
-!- add two variable (longitude and latitude).
-!- Any variable in the file can thus point to this pair
-!- through an attribute. This routine is very usefull
-!- to allow staggered grids.
-!-
-!- INPUT
-!-
-!- pfileid     : The id of the file to which the grid should be added
-!- pim         : Size in the longitude direction
-!- plon        : The longitudes
-!- plon_bounds : The boundaries of the grid in longitude
-!- plat        : The latitudes
-!- plat_bounds : Boundaries of the grid in latitude
-!- phname      : The name of grid
-!- phtitle     : The title of the grid
-!-
-!- OUTPUT
-!-
-!- phid    : Id of the created grid
-!---------------------------------------------------------------------
-  IMPLICIT NONE
-!-
-  INTEGER,INTENT(IN) :: pfileid,pim
-  REAL,DIMENSION(pim),INTENT(IN) :: plon,plat
-  REAL,DIMENSION(:,:),INTENT(IN) :: plon_bounds,plat_bounds
-  CHARACTER(LEN=*),INTENT(IN) :: phname,phtitle
-  INTEGER,INTENT(OUT) :: phid
-!-
-  CHARACTER(LEN=25) :: lon_name,lat_name
-  CHARACTER(LEN=30) :: lonbound_name,latbound_name
-  CHARACTER(LEN=80) :: tmp_title,tmp_name,longname
-  INTEGER :: ndim,dims(2)
-  INTEGER :: ndimb,dimsb(2)
-  INTEGER :: nbbounds
-  INTEGER :: nlonid,nlatid,nlonidb,nlatidb
-  INTEGER :: iret,ncid,twoid
-  LOGICAL :: transp = .FALSE.
-  REAL,ALLOCATABLE,DIMENSION(:,:) :: bounds_trans
-  LOGICAL :: l_dbg
-!---------------------------------------------------------------------
-  CALL ipsldbg (old_status=l_dbg)
-!-
-! 1.0 Check that all fits in the buffers
-!-
-  IF (    (pim /= full_size(pfileid,1)) &
-    & .OR.(full_size(pfileid,2) /= 1) ) THEN
-    CALL ipslerr (3,"histhori", &
-   &  'The new horizontal grid does not have the same size', &
-   &  'as the one provided to histbeg. This is not yet ', &
-   &  'possible in the hist package.')
-  ENDIF
-!-
-! 1.1 Create all the variables needed
-!-
-  IF (l_dbg) WRITE(*,*) 'histhori_irregular 1.0'
-!-
-  ncid = ncdf_ids(pfileid)
-!-
-  IF     (SIZE(plon_bounds,DIM=1) == pim) THEN
-    nbbounds = SIZE(plon_bounds,DIM=2)
-    transp = .TRUE.
-  ELSEIF (SIZE(plon_bounds,DIM=2) == pim) THEN
-    nbbounds = SIZE(plon_bounds,DIM=1)
-    transp = .FALSE.
-  ELSE
-    CALL ipslerr (3,"histhori", &
-   &  'The boundary variable does not have any axis corresponding', &
-   &  'to the size of the longitude or latitude variable', &
-   &  '.')
-  ENDIF
-!-
-  ALLOCATE(bounds_trans(nbbounds,pim))
-!-
-  iret = NF90_DEF_DIM (ncid,'nbnd',nbbounds,twoid)
-  ndim = 1
-  dims(1) = xid(pfileid)
-  ndimb = 2
-  dimsb(1:2) = (/ twoid,xid(pfileid) /)
-!-
-  tmp_name = phname
-  IF (nb_hax(pfileid) == 0) THEN
-    lon_name = 'nav_lon'
-    lat_name = 'nav_lat'
-  ELSE
-    lon_name = 'nav_lon_'//TRIM(tmp_name)
-    lat_name = 'nav_lat_'//TRIM(tmp_name)
-  ENDIF
-  lonbound_name = TRIM(lon_name)//'_bounds'
-  latbound_name = TRIM(lat_name)//'_bounds'
-!-
-! 1.2 Save the informations
-!-
-  phid =  nb_hax(pfileid)+1
-  nb_hax(pfileid) = phid
-!-
-  hax_name(pfileid,phid,1:2) = (/ lon_name,lat_name /)
-  tmp_title = phtitle
-!-
-! 2.0 Longitude
-!-
-  IF (l_dbg) WRITE(*,*) "histhori_irregular 2.0"
-!-
-  iret = NF90_DEF_VAR (ncid,lon_name,NF90_FLOAT,dims(1:ndim),nlonid)
-  iret = NF90_PUT_ATT (ncid,nlonid,'standard_name',"longitude")
-  iret = NF90_PUT_ATT (ncid,nlonid,'units',"degrees_east")
-  iret = NF90_PUT_ATT (ncid,nlonid,'valid_min', &
- &                     REAL(MINVAL(plon),KIND=4))
-  iret = NF90_PUT_ATT (ncid,nlonid,'valid_max', &
- &                     REAL(MAXVAL(plon),KIND=4))
-  iret = NF90_PUT_ATT (ncid,nlonid,'long_name',"Longitude")
-  iret = NF90_PUT_ATT (ncid,nlonid,'nav_model',TRIM(tmp_title))
-!-
-! 2.1 Longitude bounds
-!-
-  iret = NF90_PUT_ATT (ncid,nlonid,'bounds',TRIM(lonbound_name))
-  iret = NF90_DEF_VAR (ncid,lonbound_name,NF90_FLOAT, &
- &                     dimsb(1:ndimb),nlonidb)
-  longname = 'Boundaries for coordinate variable '//TRIM(lon_name)
-  iret = NF90_PUT_ATT (ncid,nlonidb,'long_name',TRIM(longname))
-!-
-! 3.0 Latitude
-!-
-  IF (l_dbg) WRITE(*,*) "histhori_irregular 3.0"
-!-
-  iret = NF90_DEF_VAR (ncid,lat_name,NF90_FLOAT,dims(1:ndim),nlatid)
-  iret = NF90_PUT_ATT (ncid,nlatid,'standard_name',"latitude")
-  iret = NF90_PUT_ATT (ncid,nlatid,'units',"degrees_north")
-  iret = NF90_PUT_ATT (ncid,nlatid,'valid_min', &
- &                     REAL(MINVAL(plat),KIND=4))
-  iret = NF90_PUT_ATT (ncid,nlatid,'valid_max', &
- &                     REAL(MAXVAL(plat),KIND=4))
-  iret = NF90_PUT_ATT (ncid,nlatid,'long_name',"Latitude")
-  iret = NF90_PUT_ATT (ncid,nlatid,'nav_model',TRIM(tmp_title))
-!-
-! 3.1 Latitude bounds
-!-
-  iret = NF90_PUT_ATT (ncid,nlatid,'bounds',TRIM(latbound_name))
-  iret = NF90_DEF_VAR (ncid,latbound_name,NF90_FLOAT, &
- &                     dimsb(1:ndimb),nlatidb)
-  longname = 'Boundaries for coordinate variable '//TRIM(lat_name)
-  iret = NF90_PUT_ATT (ncid,nlatidb,'long_name',TRIM(longname))
-!-
-  iret = NF90_ENDDEF (ncid)
-!-
-! 4.0 storing the geographical coordinates
-!-
-  IF (l_dbg) WRITE(*,*) "histhori_irregular 4.0"
-!-
-! 4.1 Write the longitude
-!-
-  iret = NF90_PUT_VAR (ncid,nlonid,plon(1:pim))
-!-
-! 4.2 Write the longitude bounds
-!-
-  IF (transp) THEN
-    bounds_trans = TRANSPOSE(plon_bounds)
-  ELSE
-    bounds_trans = plon_bounds
-  ENDIF
-  iret = NF90_PUT_VAR (ncid,nlonidb,bounds_trans(1:nbbounds,1:pim))
-!-
-! 4.3 Write the latitude
-!-
-  iret = NF90_PUT_VAR (ncid,nlatid,plat(1:pim))
-!-
-! 4.4 Write the latitude bounds
-!-
-  IF (transp) THEN
-    bounds_trans = TRANSPOSE(plat_bounds)
-  ELSE
-    bounds_trans = plat_bounds
-  ENDIF
-  iret = NF90_PUT_VAR (ncid,nlatidb,bounds_trans(1:nbbounds,1:pim))
-!-
-  DEALLOCATE(bounds_trans)
-!-
-  iret = NF90_REDEF (ncid)
-!--------------------------------
-END SUBROUTINE histhori_irregular
-!===
-SUBROUTINE histvert (pfileid,pzaxname,pzaxtitle,pzaxunit, &
+SUBROUTINE histvert (idf,pzaxname,pzaxtitle,pzaxunit, &
  &                   pzsize,pzvalues,pzaxid,pdirect)
 !---------------------------------------------------------------------
@@ -933,5 +796,5 @@
 !- INPUT
 !-
-!- pfileid  : ID of the file the variable should be archived in
+!- idf      : ID of the file the variable should be archived in
 !- pzaxname : Name of the vertical axis
 !- pzaxtitle: title of the vertical axis
@@ -952,5 +815,5 @@
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid,pzsize
+  INTEGER,INTENT(IN) :: idf,pzsize
   CHARACTER(LEN=*),INTENT(IN) :: pzaxname,pzaxunit,pzaxtitle
   REAL,INTENT(IN) :: pzvalues(pzsize)
@@ -960,7 +823,6 @@
   INTEGER :: pos,iv,zdimid,zaxid_tmp
   CHARACTER(LEN=70) :: str71
-  CHARACTER(LEN=80) :: str80
   CHARACTER(LEN=20) :: direction
-  INTEGER :: iret,leng,ncid
+  INTEGER :: iret,leng,nfid
   LOGICAL :: l_dbg
 !---------------------------------------------------------------------
@@ -974,6 +836,5 @@
  &                      pzaxname,'---',pzaxunit,'---',pzaxtitle
 !-
-! - Direction of axis. Can we get if from the user.
-!   If not we put unknown.
+! Direction of the vertical axis. Can we get if from the user.
 !-
   IF (PRESENT(pdirect)) THEN
@@ -986,15 +847,14 @@
 ! Check the consistency of the attribute
 !-
-  IF (     (direction /= 'unknown') &
- &    .AND.(direction /= 'up')      &
- &    .AND.(direction /= 'down')   ) THEN
+  IF (     PRESENT(pdirect)    &
+ &    .AND.(direction /= 'up') &
+ &    .AND.(direction /= 'down') ) THEN
     direction = 'unknown'
-    str80 = 'The specified axis was : '//TRIM(direction)
     CALL ipslerr (2,"histvert",&
-   & "The specified direction for the vertical axis is not possible.",&
-   & "it is replaced by : unknown",str80)
-  ENDIF
-!-
-  IF (nb_zax(pfileid)+1 > nb_zax_max) THEN
+ & "The specified positive direction for the vertical axis is invalid.",&
+ & "The value must be up or down.","The attribute will not be written.")
+  ENDIF
+!-
+  IF (W_F(idf)%n_zax+1 > nb_zax_max) THEN
     CALL ipslerr (3,"histvert", &
    &  'Table of vertical axes too small. You should increase ',&
@@ -1003,7 +863,7 @@
   ENDIF
 !-
-  iv = nb_zax(pfileid)
+  iv = W_F(idf)%n_zax
   IF (iv > 1) THEN
-    CALL find_str (zax_name(pfileid,1:iv-1),pzaxname,pos)
+    CALL find_str (W_F(idf)%zax_name(1:iv-1),pzaxname,pos)
   ELSE
     pos = 0
@@ -1012,5 +872,5 @@
   IF (pos > 0) THEN
     WRITE(str71,'("Check variable ",A," in file",I3)') &
- &    TRIM(pzaxname),pfileid
+ &    TRIM(pzaxname),idf
     CALL ipslerr (3,"histvert", &
  &    "Vertical axis already exists",TRIM(str71), &
@@ -1018,5 +878,5 @@
   ENDIF
 !-
-  iv = nb_zax(pfileid)+1
+  iv = W_F(idf)%n_zax+1
 !-
 ! 2.0 Add the information to the file
@@ -1025,31 +885,33 @@
  &  WRITE(*,*) "histvert : 2.0 Add the information to the file"
 !-
-  ncid = ncdf_ids(pfileid)
+  nfid = W_F(idf)%ncfid
 !-
   leng = MIN(LEN_TRIM(pzaxname),20)
-  iret = NF90_DEF_DIM (ncid,pzaxname(1:leng),pzsize,zaxid_tmp)
-  iret = NF90_DEF_VAR (ncid,pzaxname(1:leng),NF90_FLOAT, &
+  iret = NF90_DEF_DIM (nfid,pzaxname(1:leng),pzsize,zaxid_tmp)
+  iret = NF90_DEF_VAR (nfid,pzaxname(1:leng),NF90_REAL4, &
  &                     zaxid_tmp,zdimid)
-  iret = NF90_PUT_ATT (ncid,zdimid,'axis',"Z")
-  iret = NF90_PUT_ATT (ncid,zdimid,'standard_name',"model_level_number")
+  iret = NF90_PUT_ATT (nfid,zdimid,'axis',"Z")
+  iret = NF90_PUT_ATT (nfid,zdimid,'standard_name',"model_level_number")
   leng = MIN(LEN_TRIM(pzaxunit),20)
   IF (leng > 0) THEN
-    iret = NF90_PUT_ATT (ncid,zdimid,'units',pzaxunit(1:leng))
-  ENDIF
-  iret = NF90_PUT_ATT (ncid,zdimid,'positive',TRIM(direction))
-  iret = NF90_PUT_ATT (ncid,zdimid,'valid_min', &
+    iret = NF90_PUT_ATT (nfid,zdimid,'units',pzaxunit(1:leng))
+  ENDIF
+  IF (direction /= 'unknown') THEN
+    iret = NF90_PUT_ATT (nfid,zdimid,'positive',TRIM(direction))
+  ENDIF
+  iret = NF90_PUT_ATT (nfid,zdimid,'valid_min', &
  &                     REAL(MINVAL(pzvalues(1:pzsize)),KIND=4))
-  iret = NF90_PUT_ATT (ncid,zdimid,'valid_max', &
+  iret = NF90_PUT_ATT (nfid,zdimid,'valid_max', &
  &                     REAL(MAXVAL(pzvalues(1:pzsize)),KIND=4))
   leng = MIN(LEN_TRIM(pzaxname),20)
-  iret = NF90_PUT_ATT (ncid,zdimid,'title',pzaxname(1:leng))
+  iret = NF90_PUT_ATT (nfid,zdimid,'title',pzaxname(1:leng))
   leng = MIN(LEN_TRIM(pzaxtitle),80)
-  iret = NF90_PUT_ATT (ncid,zdimid,'long_name',pzaxtitle(1:leng))
-!-
-  iret = NF90_ENDDEF (ncid)
-!-
-  iret = NF90_PUT_VAR (ncid,zdimid,pzvalues(1:pzsize))
-!-
-  iret = NF90_REDEF (ncid)
+  iret = NF90_PUT_ATT (nfid,zdimid,'long_name',pzaxtitle(1:leng))
+!-
+  iret = NF90_ENDDEF (nfid)
+!-
+  iret = NF90_PUT_VAR (nfid,zdimid,pzvalues(1:pzsize))
+!-
+  iret = NF90_REDEF (nfid)
 !-
 !- 3.0 add the information to the common
@@ -1058,16 +920,16 @@
   &  WRITE(*,*) "histvert : 3.0 add the information to the common"
 !-
-  nb_zax(pfileid) = iv
-  zax_size(pfileid,iv) = pzsize
-  zax_name(pfileid,iv) = pzaxname
-  zax_ids(pfileid,iv) = zaxid_tmp
-  pzaxid =  iv
+  W_F(idf)%n_zax = iv
+  W_F(idf)%zax_size(iv) = pzsize
+  W_F(idf)%zax_name(iv) = pzaxname
+  W_F(idf)%zax_ids(iv) = zaxid_tmp
+  pzaxid = iv
 !----------------------
 END SUBROUTINE histvert
 !===
-SUBROUTINE histdef (pfileid,pvarname,ptitle,punit, &
- &                  pxsize,pysize,phoriid,pzsize,  &
- &                  par_oriz,par_szz,pzid,         &
- &                  pnbbyt,popp,pfreq_opp,pfreq_wrt,var_range)
+SUBROUTINE histdef &
+ &  (idf,pvarname,ptitle,punit, &
+ &   pxsize,pysize,phoriid,pzsize,par_oriz,par_szz,pzid, &
+ &   xtype,popp,pfreq_opp,pfreq_wrt,var_range,standard_name)
 !---------------------------------------------------------------------
 !- With this subroutine each variable to be archived on the history
@@ -1080,5 +942,5 @@
 !- INPUT
 !-
-!- pfileid  : ID of the file the variable should be archived in
+!- idf      : ID of the file the variable should be archived in
 !- pvarname : Name of the variable, short and easy to remember
 !- ptitle   : Full name of the variable
@@ -1104,5 +966,5 @@
 !- pzid     : ID of the vertical axis to use. It has to have
 !-            the size of the zoom.
-!- pnbbyt   : Number of bytes on which to store in netCDF (Not opp.)
+!- xtype    : External netCDF type (hist_r4/hist_r8)
 !- popp     : Operation to be performed. The following options
 !-            exist today :
@@ -1120,19 +982,18 @@
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid,pxsize,pysize,pzsize,pzid
-  INTEGER,INTENT(IN) :: par_oriz,par_szz,pnbbyt,phoriid
+  INTEGER,INTENT(IN) :: idf,pxsize,pysize,pzsize,pzid
+  INTEGER,INTENT(IN) :: par_oriz,par_szz,xtype,phoriid
   CHARACTER(LEN=*),INTENT(IN) :: pvarname,punit,popp,ptitle
   REAL,INTENT(IN) :: pfreq_opp,pfreq_wrt
   REAL,DIMENSION(2),OPTIONAL,INTENT(IN) :: var_range
-!-
-  INTEGER :: iv,i
+  CHARACTER(LEN=*),OPTIONAL,INTENT(IN) :: standard_name
+!-
+  INTEGER :: iv
   CHARACTER(LEN=70) :: str70,str71,str72
   CHARACTER(LEN=20) :: tmp_name
   CHARACTER(LEN=40) :: str40
   CHARACTER(LEN=10) :: str10
-  CHARACTER(LEN=80) :: tmp_str80
-  CHARACTER(LEN=7) :: tmp_topp,tmp_sopp(nbopp_max)
   CHARACTER(LEN=120) :: ex_topps
-  REAL :: tmp_scal(nbopp_max),un_an,un_jour,test_fopp,test_fwrt
+  REAL :: un_an,un_jour,test_fopp,test_fwrt
   INTEGER :: pos,buff_sz
   LOGICAL :: l_dbg
@@ -1142,6 +1003,6 @@
   ex_topps = 'ave, inst, t_min, t_max, t_sum, once, never, l_max, l_min'
 !-
-  nb_var(pfileid) = nb_var(pfileid)+1
-  iv = nb_var(pfileid)
+  W_F(idf)%n_var = W_F(idf)%n_var+1
+  iv = W_F(idf)%n_var
 !-
   IF (iv > nb_var_max) THEN
@@ -1158,5 +1019,5 @@
 !-
   IF (iv > 1) THEN
-    CALL find_str (name(pfileid,1:iv-1),pvarname,pos)
+    CALL find_str (W_F(idf)%W_V(1:iv-1)%v_name,pvarname,pos)
   ELSE
     pos = 0
@@ -1166,61 +1027,67 @@
     str70 = "Variable already exists"
     WRITE(str71,'("Check variable  ",a," in file",I3)') &
- &    TRIM(pvarname),pfileid
+ &    TRIM(pvarname),idf
     str72 = "Can also be a wrong file ID in another declaration"
     CALL ipslerr (3,"histdef",str70,str71,str72)
   ENDIF
 !-
-  name(pfileid,iv) = pvarname
-  title(pfileid,iv) = ptitle
-  unit_name(pfileid,iv) = punit
-  tmp_name =  name(pfileid,iv)
+  W_F(idf)%W_V(iv)%v_name = pvarname
+  W_F(idf)%W_V(iv)%title = ptitle
+  W_F(idf)%W_V(iv)%unit_name = punit
+  IF (PRESENT(standard_name)) THEN
+    W_F(idf)%W_V(iv)%std_name = standard_name
+  ELSE
+    W_F(idf)%W_V(iv)%std_name = ptitle
+  ENDIF
+  tmp_name = W_F(idf)%W_V(iv)%v_name
 !-
 ! 1.1 decode the operations
 !-
-  fullop(pfileid,iv) = popp
-  tmp_str80 = popp
+  W_F(idf)%W_V(iv)%fullop = popp
   CALL buildop &
- &  (tmp_str80,ex_topps,tmp_topp,nbopp_max,missing_val, &
- &   tmp_sopp,tmp_scal,nbopp(pfileid,iv))
-!-
-  topp(pfileid,iv) = tmp_topp
-  DO i=1,nbopp(pfileid,iv)
-    sopps(pfileid,iv,i) = tmp_sopp(i)
-    scal(pfileid,iv,i) = tmp_scal(i)
-  ENDDO
+ &  (TRIM(popp),ex_topps,W_F(idf)%W_V(iv)%topp,missing_val, &
+ &   W_F(idf)%W_V(iv)%sopp,W_F(idf)%W_V(iv)%scal, &
+ &   W_F(idf)%W_V(iv)%nbopp)
 !-
 ! 1.2 If we have an even number of operations
 !     then we need to add identity
 !-
-  IF (2*INT(nbopp(pfileid,iv)/2.0) == nbopp(pfileid,iv)) THEN
-    nbopp(pfileid,iv) = nbopp(pfileid,iv)+1
-    sopps(pfileid,iv,nbopp(pfileid,iv)) = 'ident'
-    scal(pfileid,iv,nbopp(pfileid,iv)) = missing_val
+  IF ( MOD(W_F(idf)%W_V(iv)%nbopp,2) == 0) THEN
+    W_F(idf)%W_V(iv)%nbopp = W_F(idf)%W_V(iv)%nbopp+1
+    W_F(idf)%W_V(iv)%sopp(W_F(idf)%W_V(iv)%nbopp) = 'ident'
+    W_F(idf)%W_V(iv)%scal(W_F(idf)%W_V(iv)%nbopp) = missing_val
+  ENDIF
+!-
+! 1.3 External type of the variable
+!-
+  IF (xtype == hist_r8) THEN
+    W_F(idf)%W_V(iv)%v_typ = hist_r8
+  ELSE
+    W_F(idf)%W_V(iv)%v_typ = hist_r4
   ENDIF
 !-
 ! 2.0 Put the size of the variable in the common and check
 !-
-  IF (l_dbg) &
- &  WRITE(*,*) "histdef : 2.0",pfileid,iv,nbopp(pfileid,iv), &
- &    sopps(pfileid,iv,1:nbopp(pfileid,iv)), &
- &    scal(pfileid,iv,1:nbopp(pfileid,iv))
-!-
-  scsize(pfileid,iv,1:3) = (/ pxsize,pysize,pzsize /)
-!-
-  zorig(pfileid,iv,1:3) = &
- &  (/ slab_ori(pfileid,1),slab_ori(pfileid,2),par_oriz /)
-!-
-  zsize(pfileid,iv,1:3) = &
- &  (/ slab_sz(pfileid,1),slab_sz(pfileid,2),par_szz /)
-!-
-! Is the size of the full array the same as that of the coordinates  ?
-!-
-  IF (    (pxsize > full_size(pfileid,1)) &
- &    .OR.(pysize > full_size(pfileid,2)) ) THEN
+  IF (l_dbg) THEN
+    WRITE(*,*) "histdef : 2.0",idf,iv,W_F(idf)%W_V(iv)%nbopp, &
+ &    W_F(idf)%W_V(iv)%sopp(1:W_F(idf)%W_V(iv)%nbopp), &
+ &    W_F(idf)%W_V(iv)%scal(1:W_F(idf)%W_V(iv)%nbopp)
+  ENDIF
+!-
+  W_F(idf)%W_V(iv)%scsize(1:3) = (/ pxsize,pysize,pzsize /)
+  W_F(idf)%W_V(iv)%zorig(1:3) = &
+ &  (/ W_F(idf)%slab_ori(1),W_F(idf)%slab_ori(2),par_oriz /)
+  W_F(idf)%W_V(iv)%zsize(1:3) = &
+ &  (/ W_F(idf)%slab_siz(1),W_F(idf)%slab_siz(2),par_szz /)
+!-
+! Is the size of the full array the same as that of the coordinates ?
+!-
+  IF (    (pxsize > W_F(idf)%full_size(1)) &
+ &    .OR.(pysize > W_F(idf)%full_size(2)) ) THEN
 !-
     str70 = "The size of the variable is different "// &
  &          "from the one of the coordinates"
     WRITE(str71,'("Size of coordinates :",2I4)') &
- &   full_size(pfileid,1),full_size(pfileid,2)
+ &   W_F(idf)%full_size(1),W_F(idf)%full_size(2)
     WRITE(str72,'("Size declared for variable ",a," :",2I4)') &
  &   TRIM(tmp_name),pxsize,pysize
@@ -1228,13 +1095,13 @@
   ENDIF
 !-
-! Is the size of the zoom smaler than the coordinates ?
-!-
-  IF (    (full_size(pfileid,1) < slab_sz(pfileid,1)) &
- &    .OR.(full_size(pfileid,2) < slab_sz(pfileid,2)) ) THEN
+! Is the size of the zoom smaller than the coordinates ?
+!-
+  IF (    (W_F(idf)%full_size(1) < W_F(idf)%slab_siz(1)) &
+ &    .OR.(W_F(idf)%full_size(2) < W_F(idf)%slab_siz(2)) ) THEN
     str70 = &
  &   "Size of variable should be greater or equal to those of the zoom"
     WRITE(str71,'("Size of XY zoom :",2I4)') &
- &   slab_sz(pfileid,1),slab_sz(pfileid,1)
-    WRITE(str72,'("Size declared for variable ",a," :",2I4)') &
+ &   W_F(idf)%slab_siz(1),W_F(idf)%slab_siz(2)
+    WRITE(str72,'("Size declared for variable ",A," :",2I4)') &
  &   TRIM(tmp_name),pxsize,pysize
     CALL ipslerr (3,"histdef",str70,str71,str72)
@@ -1244,8 +1111,8 @@
 !     and a fall back onto the default grid
 !-
-  IF ( (phoriid > 0).AND.(phoriid <= nb_hax(pfileid)) ) THEN
-    var_haxid(pfileid,iv) = phoriid
+  IF ( (phoriid > 0).AND.(phoriid <= W_F(idf)%n_hax) ) THEN
+    W_F(idf)%W_V(iv)%h_axid = phoriid
   ELSE
-    var_haxid(pfileid,iv) = 1
+    W_F(idf)%W_V(iv)%h_axid = 1
     CALL ipslerr (2,"histdef", &
    &  'We use the default grid for variable as an invalide',&
@@ -1259,7 +1126,7 @@
 !-- Does the vertical coordinate exist ?
 !-
-    IF (pzid > nb_zax(pfileid)) THEN
+    IF (pzid > W_F(idf)%n_zax) THEN
       WRITE(str70, &
- &    '("The vertical coordinate chosen for variable ",a)') &
+ &    '("The vertical coordinate chosen for variable ",A)') &
  &     TRIM(tmp_name)
       str71 = " Does not exist."
@@ -1269,14 +1136,14 @@
 !-- Is the vertical size of the variable equal to that of the axis ?
 !-
-    IF (par_szz /= zax_size(pfileid,pzid)) THEN
+    IF (par_szz /= W_F(idf)%zax_size(pzid)) THEN
       str70 = "The size of the zoom does not correspond "// &
  &            "to the size of the chosen vertical axis"
       WRITE(str71,'("Size of zoom in z :",I4)') par_szz
       WRITE(str72,'("Size declared for axis ",A," :",I4)') &
- &     TRIM(zax_name(pfileid,pzid)),zax_size(pfileid,pzid)
+ &     TRIM(W_F(idf)%zax_name(pzid)),W_F(idf)%zax_size(pzid)
       CALL ipslerr (3,"histdef",str70,str71,str72)
     ENDIF
 !-
-!-- Is the zoom smaler that the total size of the variable ?
+!-- Is the zoom smaller that the total size of the variable ?
 !-
     IF (pzsize < par_szz) THEN
